; 
    include \masm32\include\masm32rt.inc
    .586
    include counter2.asm
; 
    .data
      array2    dw 10 dup(1122h)
      array4    dd 10 dup(11223344h)
      array8    dq 10 dup(1122334455667788h)
      _array8   dq 10 dup(1122334455667788h)
      __array8  dq 10 dup(1122334455667788h)
    .code
; 

align 16
Endian2 proc endianInput:dword, endianOutput:dword
    mov edx, endianInput                ;mem = B1 B2
    mov ax, word ptr[edx]               ;ax = B2 B1
    xchg al, ah                         ;ax = B1 B2
    mov edx, endianOutput
    mov word ptr[edx], ax               ;mem = B2 B1
    ret
Endian2 endp

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
align 16
_Endian2 proc endianInput:dword, endianOutput:dword
    mov ecx, [esp+4]
    mov edx, [esp+8]
    movzx eax, word ptr[ecx]
    shl eax, 8
    bswap eax
    shr eax, 8
    mov [edx], ax
    ret 8
_Endian2 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

align 16
Endian2Array proc endianInput:dword, endianOutput:dword, arrayCount:dword
    mov ecx, arrayCount
    test ecx, ecx
    je doneEndian2Array
  nextEndian2Array:
    mov edx, endianInput                ;mem = B1 B2
    mov ax, word ptr[edx+2*ecx-2]       ;ax = B2 B1
    xchg al, ah                         ;ax = B1 B2
    mov edx, endianOutput
    mov word ptr[edx+2*ecx-2], ax       ;mem = B2 B1
    dec ecx
    test ecx, ecx
    je doneEndian2Array
    jmp nextEndian2Array
  doneEndian2Array:
    ret
Endian2Array endp

align 16
_Endian2Array proc endianInput:dword, endianOutput:dword, arrayCount:dword
    push ebx
    mov ecx, arrayCount
    mov ebx, endianInput
    mov edx, endianOutput
    test ecx, ecx
    je doneEndian2Array
  nextEndian2Array:
    movzx eax, word ptr[ebx+2*ecx-2]
    shl eax, 8
    bswap eax
    shr eax, 8
    mov [edx+2*ecx-2], ax
    dec ecx
    jnz nextEndian2Array
  doneEndian2Array:
    pop ebx
    ret
_Endian2Array endp
align 16

Endian4 proc endianInput:dword, endianOutput:dword
    mov edx, endianInput                ;mem = B1 B2 B3 B4
    mov ax, word ptr[edx]               ;ax = B2 B1
    mov bx, word ptr[edx+2]             ;bx = B4 B3
    xchg al, ah                         ;ax = B1 B2
    xchg bl, bh                         ;bx = B3 B4
    shl eax, 16                         ;eax = B1 B2 00 00
    mov ax, bx                          ;eax = B1 B2 B3 B4
    mov edx, endianOutput
    mov dword ptr[edx], eax             ;mem = B4 B3 B2 B1
    ret
Endian4 endp

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE
align 16
_Endian4 proc endianInput:dword, endianOutput:dword
    mov ecx, [esp+4]
    mov edx, [esp+8]
    mov eax, [ecx]
    bswap eax
    mov [edx], eax
    ret 8
_Endian4 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

align 16
Endian4Array proc endianInput:dword, endianOutput:dword, arrayCount:dword
    mov ecx, arrayCount
    test ecx, ecx
    je doneEndian4Array
  nextEndian4Array:
    mov edx, endianInput                ;mem = B1 B2 B3 B4
    mov ax, word ptr[edx+4*ecx-4]       ;ax = B2 B1
    mov bx, word ptr[edx+4*ecx-2]       ;bx = B4 B3
    xchg al, ah                         ;ax = B1 B2
    xchg bl, bh                         ;bx = B3 B4
    shl eax, 16                         ;eax = B1 B2 00 00
    mov ax, bx                          ;eax = B1 B2 B3 B4
    mov edx, endianOutput
    mov dword ptr[edx+4*ecx-4], eax     ;mem = B4 B3 B2 B1
    dec ecx
    test ecx, ecx
    je doneEndian4Array
    jmp nextEndian4Array
  doneEndian4Array:
    ret
Endian4Array endp

align 16
_Endian4Array proc endianInput:dword, endianOutput:dword, arrayCount:dword
    push ebx
    mov ecx, arrayCount
    mov ebx, endianInput
    mov edx, endianOutput
    test ecx, ecx
    je doneEndian4Array
  nextEndian4Array:
    mov eax, [ebx+4*ecx-4]
    bswap eax
    mov [edx+4*ecx-4], eax
    dec ecx
    jnz nextEndian4Array
  doneEndian4Array:
    pop ebx
    ret
_Endian4Array endp

align 16
Endian8 proc endianInput:dword, endianOutput:dword
    mov edx, endianInput                ;mem = B1 B2 B3 B4 B5 B6 B7 B8
    mov ax, word ptr[edx]               ;ax = B2 B1
    mov bx, word ptr[edx+2]             ;bx = B4 B3
    xchg al, ah                         ;ax = B1 B2
    xchg bl, bh                         ;bx = B3 B4
    shl eax, 16                         ;eax = B1 B2 00 00
    mov ax, bx                          ;eax = B1 B2 B3 B4
    mov edx, endianOutput
    mov dword ptr[edx+4], eax           ;mem = B4 B3 B2 B1

    mov edx, endianInput                ;mem = B1 B2 B3 B4 B5 B6 B7 B8
    mov ax, word ptr[edx+4]             ;ax = B6 B5
    mov bx, word ptr[edx+6]             ;bx = B8 B7
    xchg al, ah                         ;ax = B5 B6
    xchg bl, bh                         ;bx = B7 B8
    shl eax, 16                         ;eax = B5 B6 00 00
    mov ax, bx                          ;eax = B5 B6 B7 B8
    mov edx, endianOutput
    mov dword ptr[edx], eax             ;mem = B8 B7 B6 B5
    ret
Endian8 endp

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
align 16
_Endian8 proc endianInput:dword, endianOutput:dword
    push ebx
    mov ebx, [esp+8]
    mov edx, [esp+12]
    mov eax, [ebx]
    mov ecx, [ebx+4]
    bswap eax
    bswap ecx
    mov [edx+4], eax
    mov [edx], ecx
    pop ebx
    ret 8
_Endian8 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

align 16
Endian8Array proc endianInput:dword, endianOutput:dword, arrayCount:dword
    mov ecx, arrayCount
    test ecx, ecx
    je doneEndian8Array
  nextEndian8Array:
    mov edx, endianInput                ;mem = B1 B2 B3 B4 B5 B6 B7 B8
    mov ax, word ptr[edx+8*ecx-8]       ;ax = B2 B1
    mov bx, word ptr[edx+8*ecx-6]       ;bx = B4 B3
    xchg al, ah                         ;ax = B1 B2
    xchg bl, bh                         ;bx = B3 B4
    shl eax, 16                         ;eax = B1 B2 00 00
    mov ax, bx                          ;eax = B1 B2 B3 B4
    mov edx, endianOutput
    mov dword ptr[edx+8*ecx-4], eax     ;mem = B4 B3 B2 B1

    mov edx, endianInput                ;mem = B5 B6 B7 B8
    mov ax, word ptr[edx+8*ecx-4]       ;ax = B6 B5
    mov bx, word ptr[edx+8*ecx-2]       ;bx = B8 B7
    xchg al, ah                         ;ax = B5 B6
    xchg bl, bh                         ;bx = B7 B8
    shl eax, 16                         ;eax = B5 B6 00 00
    mov ax, bx                          ;eax = B5 B6 B7 B8
    mov edx, endianOutput
    mov dword ptr[edx+8*ecx-8], eax     ;mem = B8 B7 B6 B5

    dec ecx
    test ecx, ecx
    je doneEndian8Array
    jmp nextEndian8Array
  doneEndian8Array:
    ret
Endian8Array endp

align 16
_Endian8Array proc endianInput:dword, endianOutput:dword, arrayCount:dword
    push ebx
    push edi
    mov ecx, arrayCount
    mov ebx, endianInput
    mov edx, endianOutput
    test ecx, ecx
    je doneEndian8Array
  nextEndian8Array:
    mov eax, [ebx+8*ecx-8]
    mov edi, [ebx+8*ecx-4]
    bswap eax
    bswap edi
    mov [edx+8*ecx-4], eax
    mov [edx+8*ecx-8], edi    
    dec ecx
    jnz nextEndian8Array
  doneEndian8Array:
    pop edi
    pop ebx
    ret
_Endian8Array endp

; 
start:
; 

    print "Endian2:",9
    movzx eax, array2
    print uhex$(eax),9
    invoke Endian2, ADDR array2, ADDR array2
    movzx eax, array2
    print uhex$(eax),13,10

    print "_Endian2:",9
    movzx eax, array2
    print uhex$(eax),9
    invoke _Endian2, ADDR array2, ADDR array2
    movzx eax, array2
    print uhex$(eax),13,10

    print "Endian2Array:",9
    movzx eax, array2
    print uhex$(eax),9
    invoke Endian2Array, ADDR array2, ADDR array2, 1
    movzx eax, array2
    print uhex$(eax),13,10

    print "_Endian2Array:",9
    movzx eax, array2
    print uhex$(eax),9
    invoke _Endian2Array, ADDR array2, ADDR array2, 1
    movzx eax, array2
    print uhex$(eax),13,10

    print "Endian4:",9
    print uhex$(array4),9
    invoke Endian4, ADDR array4, ADDR array4
    print uhex$(array4),13,10

    print "_Endian4:",9
    print uhex$(array4),9
    invoke _Endian4, ADDR array4, ADDR array4
    print uhex$(array4),13,10

    print "Endian4Array:",9
    print uhex$(array4),9
    invoke Endian4Array, ADDR array4, ADDR array4, 1
    print uhex$(array4),13,10

    print "_Endian4Array:",9
    print uhex$(array4),9
    invoke _Endian4Array, ADDR array4, ADDR array4, 1
    print uhex$(array4),13,10

    print "Endian8:",9
    print uhex$(dword ptr _array8+4)
    print uhex$(dword ptr _array8),9
    invoke Endian8, ADDR _array8, ADDR _array8
    print uhex$(dword ptr _array8+4)
    print uhex$(dword ptr _array8),13,10

    print "_Endian8:",9
    print uhex$(dword ptr array8+4)
    print uhex$(dword ptr array8),9
    invoke _Endian8, ADDR array8, ADDR array8
    print uhex$(dword ptr array8+4)
    print uhex$(dword ptr array8),13,10

    print "Endian8Array:",9
    print uhex$(dword ptr __array8+4)
    print uhex$(dword ptr __array8),9
    invoke Endian8Array, ADDR __array8, ADDR __array8, 1
    print uhex$(dword ptr __array8+4)
    print uhex$(dword ptr __array8),13,10

    print "_Endian8Array:",9
    print uhex$(dword ptr array8+4)
    print uhex$(dword ptr array8),9
    invoke _Endian8Array, ADDR array8, ADDR array8, 1
    print uhex$(dword ptr array8+4)
    print uhex$(dword ptr array8),13,10

    invoke Sleep, 2000

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke Endian2, ADDR array2, ADDR array2
    ctr_end
    print ustr$(eax)," cycles, Endian2",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke _Endian2, ADDR array2, ADDR array2
    ctr_end
    print ustr$(eax)," cycles, _Endian2",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke Endian2Array, ADDR array2, ADDR array2, 10
    ctr_end
    print ustr$(eax)," cycles, Endian2Array",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke _Endian2Array, ADDR array2, ADDR array2, 10
    ctr_end
    print ustr$(eax)," cycles, _Endian2Array",13,10


    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke Endian4, ADDR array4, ADDR array4
    ctr_end
    print ustr$(eax)," cycles, Endian4",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke _Endian4, ADDR array4, ADDR array4
    ctr_end
    print ustr$(eax)," cycles, _Endian4",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke Endian4Array, ADDR array4, ADDR array4, 10
    ctr_end
    print ustr$(eax)," cycles, Endian4Array",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke _Endian4Array, ADDR array4, ADDR array4, 10
    ctr_end
    print ustr$(eax)," cycles, _Endian4Array",13,10


    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke Endian8, ADDR array2, ADDR array8
    ctr_end
    print ustr$(eax)," cycles, Endian8",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke _Endian8, ADDR array2, ADDR array8
    ctr_end
    print ustr$(eax)," cycles, _Endian8",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke Endian8Array, ADDR array8, ADDR array8, 10
    ctr_end
    print ustr$(eax)," cycles, Endian8Array",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke _Endian8Array, ADDR array8, ADDR array8, 10
    ctr_end
    print ustr$(eax)," cycles, _Endian8Array",13,10


    inkey "Press any key to exit..."
    exit
; 
end start
